/* See LICENSE for copyright and distribution details.
 * Copyright Ryan Raymond 2022
 */

#include "main.h"

gint
main(gint argc, gchar *argv[])
{
	int i;
	guint drops,
	      spawn_tries,
	      spawn_chance,
	      length_min,
	      length_max;

	struct winsize terminal_dimensions;
	struct matrix *_matrix;

	gchar *frame_buffer;
	GList *first, *last;

	printf("\e[?25l");
	srand(time(NULL));

	spawn_chance=5;
	spawn_tries=5;

	terminal_dimensions.ws_row = 1;
	terminal_dimensions.ws_col = 1;

	length_min = 5;
	length_max = 10;

	_matrix = matrix_new(terminal_dimensions.ws_col,
			     terminal_dimensions.ws_row);
	//frame_buffer_update();

	drops = 0;
	first = NULL;	
	last = NULL;	
	
	for(i=1;i<100;i++)
	{
		if (check_size(&terminal_dimensions)){
			//printf("Terminal dimensions changed to %dx%d\n",
			//	terminal_dimensions.ws_col,
			//	terminal_dimensions.ws_row);
			gchar new_matrix[terminal_dimensions.ws_col]
					[terminal_dimensions.ws_col];
			_matrix = matrix_new(terminal_dimensions.ws_col,
					     terminal_dimensions.ws_row);
			//frame_buffer_update();
			//printf("New Mtrix: %ldx%ld", sizeof(_matrix.rows->cells[0]), sizeof(_matrix));
			//printf("New Matrix: %ldx%ld", sizeof(matrix), sizeof(matrix));
		}
		spawn(spawn_tries, spawn_chance, &first, &last,
		      terminal_dimensions, length_min, length_max);
		advance(terminal_dimensions, first);
		
		//_matrix = matrix_new(terminal_dimensions.ws_col,
		//		     terminal_dimensions.ws_row);
		//printf("Address of matrix: %p\n", _matrix);
		//printf("Address of row: %p\n", & (_matrix->rows[0]) );
		//printf("Address of row 1: %p\n", & (_matrix->rows[0]) );
		//printf("Value of row   2: %p\n", & ( _matrix->rows[1] ) );

		//printf("Cell one: %p\nCell two: %p\n",
		//       & ( _matrix->rows[0].cells[0] ),
		//       & ( _matrix->rows[1].cells[0] ) );
		draw(first, _matrix, &terminal_dimensions);
		//printf("%d out of 1000\n", i);
		usleep(50000);
	
	}
	printf("\e[?25h");
	return 0;

}

